\documentclass[unknownkeysallowed]{beamer}
\mode<presentation>{
\usetheme{TalkLIAG} 
\usecolortheme[RGB={0,66,136}]{structure}
\setbeamercovered{transparent}
\beamertemplatenavigationsymbolsempty
\beamertemplatetransparentcovereddynamic
}

\usepackage{beamerfontthemeprofessionalfonts}
\usepackage[german]{babel}
\usepackage[T1]{fontenc}
\usepackage[utf8]{inputenc}
%\usepackage{amsmath}
%\usepackage{amssymb}
\usepackage{pslatex}
%\usepackage{xspace}
%\usepackage{array}
\usepackage{comment}
\usepackage{url}
\usepackage{graphicx}
\usepackage{overpic}
\graphicspath{{pics/}} 
\renewcommand{\d}{{\bf d}}
\newcommand{\f}{{\bf f}}
\newcommand{\m}{{\bf m}}
\newcommand{\W}{{\bf W}}

%\usepackage{listings} 
%\lstloadlanguages{Python,bash} 
%\lstdefinelanguage{Python}{backgroundcolor=\color{yellow!15},morekeywords={pygimli,numpy,pylab,import,from,for,in,print,enumerate,zip}} 

\setlength{\parindent}{0pt}

%\hypersetup{pdfpagemode={FullScreen}}
\pgfdeclareimage[height=1.3cm]{liaglogo}{liaglogo}
\logo{\pgfuseimage{liaglogo}}

%\title[BERT workshop]{Boundless Electrical Resistivity Tomography (BERT) Workshop}
%\title{BERT-Workshop für Leipziger\\ „klassisch bis pyGIMLi/pyBERT“}
%\date{BGR, 28.10.2013}
%\author[Günther\&Rücker\&Wagner: BERT workshop]{Thomas Günther \& Carsten Rücker \& Florian Wagner}
\author[Günther\&Rücker\&Wagner: BERT workshop]{Thomas Günther \& Carsten Rücker \& Florian Wagner}
%\institute[LIAG]{Leibniz Institute for Applied Geophysics, Hannover}

\begin{document}
\setbeamertemplate{blocks}[rounded][shadow=true]

\logo{}
\begin{frame}{}{}{\titlepage}\end{frame}
%\begin{frame}{Content}{}{\tableofcontents}\end{frame} 
\AtBeginSection[]{\begin{frame}{Content}\tableofcontents[currentsection] \end{frame}}

%\section[Introduction]{Introduction - BERT, GIMLi etc.}\subsection{}

\iffalse
\begin{frame}{}
    \begin{block}{Ergebnisse der Umfrage (15 Rückmeldungen) vom September}
        \begin{itemize}
            \item Betriebssystem: 11 Windows, 4 Linux (openSuse, debian, ubuntu), 1 Mac
            \item Vorkenntnisse BERT/pyGIMLi: 4 x etwas, 11 x Null
        \item Vorkenntnisse Python: 2 x ja, 7 x etwas, 5 x Null
        \item Erfahrung mit bash: 1 x ja, 5 x etwas, 8 x Null
        \end{itemize}
    \end{block}
    \begin{block}{Vorgehen}
        \begin{itemize}
            \item Überblick über Grundlagen \& Möglichkeiten (Vortrags)
            \item Üben einfacher BERT-Fälle (manche gelangweilt?)
            \item Arbeiten mit dem ERT Manager (wirklich einfach!)
            \item Einführung in pyGIMLi (Python) mit Vorführung und Übung
            \item Vorwärtsmodellierung einfacher Fälle
            \item Spezialthemen (Timelapse, SIP, Elektroden)
            \item Fragestunde und Problemlösung
        \end{itemize}
    \end{block}
\end{frame}

\begin{frame}{}
    \begin{block}{Erwartungen}
        \begin{itemize}
            \item Was ist BERT? Features, Einstieg, Einblick in BERT (10)
            \item praktischer Umgang, Automatisierung
            \item Alternative zu res2dinv und Unterschiede dazu
            \item Einstieg/Erlernen von pyGIMLi (Vorstellung Module)
            \item Inversion von Spektraldaten erlernen (2)
        \end{itemize}
    \end{block}
    \begin{block}{Spezielle Themen}
        \begin{itemize}
            \item Timelapse-ERT und Langzeit-Monitoring (3)
            \item Einbinden von Schichtgrenzen aus Bohrungen
            \item 3D-Modellierung von Hohlräumen
            \item Bohrloch-Elektroden und full electrode model
        \end{itemize}
    \end{block}
\end{frame}

\begin{frame}{}
    \begin{block}{Unsere Erwartungen}
        \begin{itemize}
            \item Gewinnung neuer Nutzer und Partner (+Contributoren?)
            \item wichtiges Feedback aus Industrie und Forschung
            \item Verbreitung von BERT sowie pyGIMLi/pyBERT
            \item Impulse für Weiterentwicklung und Verbesserungen
        \end{itemize}
    \end{block}
    \begin{block}{Ziel des Kurses}
        \begin{itemize}
            \item Überblick über Möglichkeiten von BERT (mit pyGIMLi)
            \item Einblick in Wirkungsweise von BERT (auf Bash)
            \item Bestehende BERT-Nutzer auf aktuellen Stand bringen
            \item Einführung in pyGIMLi und pyBERT mit ERTManager
            \item Antwort auf konkrete Fragen und Problem
        \end{itemize}
    \end{block}
\end{frame}
\fi

\begin{frame}{Objectives}
\begin{itemize}
\item Basic understanding of program and possibilities
\item Overview on features, particularly new in BERT 2
\item Response to frequent questions and problems
\item Introduction into pyGIMLi and pyBERT
\item What's in development and what's missing?
\item Where can the tutorial be improved?
\end{itemize}
\end{frame}

\begin{frame}{BERT}
    \begin{block}{Unique features of BERT}
        \begin{itemize}
            \item platform-independent (Win, Linux, Mac?, Android?, ARM, HPC)
            \item open source and transparent development
            \item electrodes types (nodes, free positions, surfaces (CEM), lines (SEM)
            \item automated use and web-based inversion
            \item flexible regularization scheme (including prior information)
            \item more mesh types and transdimensional inversion
            \item more ways for normal, timelapse and SIP inversion
            \item extremely flexible use within Python using pyGIMLi/pyBERT
        \end{itemize}
    \end{block}
    \begin{block}{Drawback}
        no GUI (so far), although several plotting options
    \end{block}
\end{frame}


%\begin{frame}{Specific questions}  % BGR
%\begin{itemize}
%	\item Sensitivity and coverage, DOI, 1 A problem
%	\item IP inversion
%	\item reading Comsol mesh (mphtxt), PARAGEOMETRY etc.
%	\item fix resistivity
%	\item incorporating full geometry (mainly for cylinders)
%	\item initial values
%	\item primary/secondary field calculation (and meshes)
%	\item approaches for choosing $\lambda$
%	\item robust data inversion and reciprocal analysis
%	\item specific error (in paradepth calculation)
%\end{itemize}
%\end{frame}

\begin{frame}{Material for Reading and Trying}
\begin{itemize}
\item BERT Tutorial (about reworking): Inversion examples\\
in examples/inversion (ordered by geometry)
%\item Migration Guide from BERT 1 to 2: into Tutorial
\item BERT-HowTo: User Stories (mostly pyGIMLi HowTo)\\
in doc/HowTo/
\item Modelling examples (without Tutorial)\\
in examples/modelling
\item Articles for theory and application (list at the end)
\end{itemize}
\end{frame}

\section[Software]{Software, architecture and usage}\subsection{}
\begin{frame}{What is BERT actually?}
\begin{itemize}
\item technology of ERT inversion and modelling after G et al. (2006), R et al. (2006), R\&G (2011), R (2011), R,R\&G (2015), G\&M (2016)...
\item the C++ libraries (dcfemlib and libbert) based on GIMLi
\item Python library pybert based on pygimli with modules
\item program package with binaries, libraries, tools, examples, docu
\item the (shell) script for calling (main command)
\item WebBERT - Web service for BERT 
\end{itemize}
\begin{block}{WebBERT - Details DGG-Mitteilungen 1/2014 (in German)}
Idea: Cloud service with job scheduling and distribution\\
Advantage: spare own resources, stay always updated\\
Integrated in LIAG geophysics database (www.geophysics-database.de)
\end{block}
\end{frame}

\begin{frame}{Development of BERT}
    \begin{itemize}
        \item early versions: starting 2004, versions 1.0-1.3: 2008-2011
        \item BERT 2: 23 beta versions 2009-2013, followed by RCx$\rightarrow$2.0.x 
        \item version 2.0.1-19 (2013-2016): steady \& slow development
        \item version 2.1: documentation, bug fixing and few features\\
  (Python not strictly necessary, just for some features \& solutions)
          \item version 3 - fully depending and running on Python
          \begin{itemize}
              \item replacing of Poly/Mesh tools by Python classes
              \item replacing command line executables by ERT manager
              \item replacing shell scripts by Python scripts
            \end{itemize}
    \end{itemize}
%still in development: more intelligent bertNew* (tuning of geometry, direct data import, end topo), pro-Files (3D from 2D), 3D->2D for data and 2D->3D for model, normal-reciprocal analysis in dcedit, automated time-lapse preprocessing 
\end{frame}

\begin{frame}{Why Python?}
\begin{itemize}
\item wide-spread, free programming language
\item seamless transition from C++ programming (performant)
\item advantages of true object orienting (classes, inheritance etc.)
\item platform independence (Win, Linux, Android, Web interface)
\item numerical library NumPy (vectors, matrices, basic functions)
\item scientific collection SciPy (Toolboxes as in Matlab, but far more)
\item plotting with matplotlib (Matlab-like, but more powerful \& flexible)
\item IDE with debugging, profiling etc. (e.g. Spyder)
\item ready distributions like WinPython or Anaconda, conda packages
%\item 
\end{itemize}
\end{frame}

\begin{frame}{Software Architecture of BERT}
\includegraphics[width=\textwidth]{bert/bert-arch}
\end{frame}

\begin{frame}{pyGIMLi and BERT - behind the scenes}
    \begin{block}{Introduction into pyGIMLi}

    \end{block}
    \begin{block}{Live-Intro in pyGIMLi and BERT}
        \begin{itemize}
            \item pyGIMLi webpage with Examples, Tutorials \& API Doc\\
                \url{http://www.pygimli.org}
            \item development strategy (tests, CI, ...)
            \item gimli github repository with Issue tracker etc.\\
                \url{https://github.com/gimli-org/gimli}
            \item bert gitlab repository with Issue tracker etc.\\
                \url{https://gitlab.com/resistivity-net/bert}
            \item BERT Tutorial including User Stories\\
                \url{http://www.resistivity.net/download/bert-tutorial.pdf}
            \item BERT Workshop pdf\\
				\url{http://www.resistivity.net/download/bert-course.pdf}
        \end{itemize}
    \end{block}
\end{frame}

\begin{frame}{BERT project page on gitlab.com}
\includegraphics[width=\textwidth]{bert-gitlab}\\
follow development, FAQ, Issue tracker, links, 
\end{frame}


\begin{frame}{BERT - classic deployment on command line}
0. Prepare data and create new project using bertNew* commands
\begin{block}{Classic surface geometries}
bertNew2D, bertNew2DTopo, bertNew3D, bertNew3DTopo
\end{block}
bertNew2DTopo datafile > bert.cfg\\[1ex]
\begin{block}{bertNew* auto-imports instrument files}
	\begin{itemize}
		\item Resecs Ascii output (*.txt)
		\item LGM (Lippmann) 4-point light (*.tx0)
		\item Syscal binary files (*.bin)
		\item ABEM system files (*.amp)
		\item Geotom flow files (*.flw)
		\item res2dinv files (*.res2dinv for clarification)		
	\end{itemize}
\end{block}
\end{frame}

\begin{frame}{General procedure}
1. Optimize and control mesh parameters \\
bert bert.cfg meshes
bert bert.cfg showmesh  \# or showpoly
\begin{block}{Inversion Mesh Parameters}
PARADEPTH - depth of inversion domain\\
PARADX - Refinement at electrodes relative (2D) or absolute (3D)\\
PARABOUNDARY - Boundary around electrodes in \% of spread\\
PARA2D/3DQUALITY - Quality (growth speed with depth)\\
or regular (GRID=1, Python required):\\
LAYERS - Number of layers \\
PARADZ - Thickness of first layer (default PARADX)
\end{block}
2. Full run and plotting\\
bert bert.cfg all\\
bert bert.cfg show\\
bert bert.cfg mkpdf\\[1ex]
\end{frame}

\begin{frame}{BERT command line: General procedure}
3. More plotting\\
bert bert.cfg showdata \# apparent resistivity or any other key\\
bert bert.cfg showhist \# app. res. histogram\\
bert bert.cfg showfit \# data, response \& misfit\\
bert bert.cfg showerror \# error estimate\\
bert bert.cfg showtopoeff | showtopocorr \# topo effect|corr\\[1ex]
4. Save if desired, change options and recalculation\\
bert bert.cfg save \# result folder for later plotting/recalculation)\\
bert bert.cfg calc show\\
(put several commands after each other)\\
bert bert.cfg mkpdf\\
(only with Python, multipage pdf for Timelapse)\\[1ex]
9. Clean up\\
bert bert.cfg clean | veryclean | pack
\end{frame}

\begin{frame}{BERT options}
\begin{block}{Error estimation and data filtering (bert cfg filter)}
INPUTERRLEVEL - relative error in \%\\
INPUTERRVOLTAGE - voltage error in V\\
OVERRIDEERROR - ignore error in file\\
RMIN/RMAX - minimum/maximum $\rho_a$-values\\
KMIN/KMAX - minimum/maximum\\
ERRMAX - maximum error\\
DOWNWEIGHT - weight to zero instead of removal
\end{block}
\begin{block}{Often used inversion options}
LAMBDA - global  regularisation\\
ZWEIGHT - purely vertical regularisation\\
LAMBDAOPT - L-curve optimization (not always working)\\
CHI1OPT - optimization of $\lambda$ such that $\chi^2$=1\\
LOWERBOUND/UPPERBOUND - lower/upper bound for $\rho$\\
ROBUSTDATA - use L1 norm for data misfit (adjusting errors)\\
BLOCKYMODEL - use L1 norm for model roughness (adjusting constraints)
\end{block}
\end{frame}


\begin{frame}{BERT options}
	\begin{block}{Plotting (bert cfg show)}
		cMin/cMax - color bar limits\\
		INTERPERC - automatic alpha-trim value\\
		cMap - color scheme (e.g. jet, viridis, b2r)\\
		USECOVERAGE - alpha shading\\
		SHOWELECTRODES - plot electrodes\\
	\end{block}
bert cfg show modelfile  \# shows different model file\\
bert cfg show phase.vector  \# show phase inversion result\\
bert cfg mkpdf \# generate pdf (silently)\\
bert cfg show modelAbs.bmat  \# time-lapse multipage results\\
bert cfg show modelDiff.bmat  \# time-lapse multipage ratios pdf
\end{frame}

% Inversionsoptionen
% Datenfilterung
% Plotting Optionen (mit Python): cMin,cMax,INTERPERC,USECOVERAGE,SHOWELECTRODES

\begin{frame}[fragile,label=manager]{pyBERT and the manager}
    \begin{block}{pyBERT}
python module for doing everything in Python
\begin{verbatim}
import pybert as pb

data = pb.load('gallery.dat')
pb.show(data)
pb.show(data, data('err'))
\end{verbatim}
    \end{block}
    \begin{block}{The BERT manager}
        Python class for handling data, inversion, simulation, plotting, exporting etc.
\begin{verbatim}
import pybert as pb

res = pb.Resistivity('gallery.dat')
res.invert()
res.showResultAndFit()
\end{verbatim}
    \end{block}
\end{frame}

\begin{frame}{1st Exercise with Gallery \& Co.}{Done interactively}
	\begin{block}{}
		examples/inversion/2dflat/gallery
		\begin{itemize}
			\item create cfg File using bertNew2D und bert all
			\item bert cfg show, showdata, showfit, showpoly, showmesh, 
			\item Variation of regularisation (LAMBDA, ZWEIGHT)
			\item Variation of meshes (PARADEPTH, PARADX, PARA2DQUALITY)
			\item regular grids with GRID=1, LAYERS, PARADX/DZ
			\item Inversion with ERT manager (s. \hyperlink{manager}{\beamerbutton{Slide}})
			\item 2D with topography (slagdump), 2d crosshole
			\item 3D-flat and Paraview
		\end{itemize}
	\end{block}
\end{frame}

\section[Geometry]{Mesh types and geometry}\subsection{}
\begin{frame}{Mesh types - advantages and disadvantages}
\begin{block}{Irregular meshes (triangle, tetrahedra)} 
  arbitrary geometry (topography, regions, structural constraints),
  efficient and node-including Discretisation, 
  z.T. bad resolution for greater anisotropy (limits of ZWEIGHT)
\end{block}

\begin{block}{Regular meshes (rectangles, hexahedra)}
  mostly inefficient (many nodes and free parameters), not working for arbitrary 3D topography, advantageous for dominant layering
\end{block}

\begin{block}{Half-regular: triangle prisms}
 (dominant layering, but still efficient in x/y)\\
  z.B. long electrode ERT, 3D topography, irregular profiles
\end{block}

\begin{block}{Mixed meshes}
  region-wise usage of individual advantages\\
  e.g. layering with topography (Borkum o. Langeoog)
\end{block}
\end{frame}

\begin{frame}{2D discretization}
\begin{block}{}
\begin{itemize}
	\item<1-> triangle: arbitrary topography
	\item<2-> rectangle mesh: predominant layering
	\item<3-> mixed triangles+rectangles: both
\end{itemize}
\end{block}
\only<1>{\includegraphics[width=\textwidth]{bert/ost3-result}} %
\only<2>{\includegraphics[width=\textwidth]{bert/reg2d-result}} %
\only<3>{\includegraphics[width=\textwidth]{bert/reg2d-mesh}} %
\end{frame}

\begin{frame}{3D discretization}
\begin{block}{}
\begin{itemize}
	\item<1-> tetrahedra: arbitrary topography
	\item<2-> hexahedra: closed geometry, predominant layers
	\item<3-> mixed hexahedral/tetrahedeal mesh
	\item<4-> triangle prisms: topo+layering, long electrodes
\end{itemize}
\end{block}
\vfill\centering
\only<1>{Point du Hoc (Udphuay et al., 2011)
\includegraphics[width=0.5\textwidth]{pdh/meshinput}%
\includegraphics[width=0.37\textwidth]{pdh/result-1}}%
\only<2>{Lysimeter (Bechtold et al., 2011)
\includegraphics[width=0.4\textwidth]{bechtold/setup1}%
\includegraphics[width=0.37\textwidth]{bechtold/model1}}%
\only<3>{Coupling with Hydrus model (Noell et al., 201x)
\includegraphics[width=0.4\textwidth]{bert/reg3d-mesh}}%
\only<4>{Long Electrode ERT (Ronczka et al., 2015)
\includegraphics[width=0.65\textwidth]{samoleg/figure11b}}%
\end{frame}

\begin{frame}{3D Mesh generation}{Point du Hoc, Normandie (Udphuay et al., 2011)}{%
\only<1>{Delaunay surface mesh, electrodes (red) and polygons (green)}%
\only<2>{Resulting mesh without polygones}%
\only<3>{Resulting mesh with polygones}%
\only<4>{Inversion result}%
\strut}%
\begin{center}%
\includegraphics<1>[width=0.85\columnwidth]{pdh/meshinput}%
\includegraphics<2>[width=0.9\columnwidth]{pdh/withoutpoly}%
\includegraphics<3>[width=0.9\columnwidth]{pdh/withpoly}%
\includegraphics<4>[width=0.6\columnwidth]{pdh/result-1}%
\end{center}
\end{frame} 

\begin{frame}{Ways to define geometry}
\begin{block}{PARAMESH (mesh file, command, shell script, Python script)}
  generates mesh/mesh.bms (and mesh/mesh.poly if needed)
\end{block}
\begin{block}{PARAGEOMETRY (poly file, command, shell script, Python script)}
generates mesh/mesh.poly $\Rightarrow$ input for mesh generator
\end{block}
\begin{block}{GRID=1, with PARADX/DZ, PARADEPTH, LAYERS, PARABOUNDARY}
 generates regular grids (Python needed)
\end{block}
\begin{block}{else}
automatic generation from data as in BERT 1 (using PARADX, PARADEPTH, PARABOUNDARY, TOPOPOINTS, TOPOPOLY etc.)
\end{block}
\end{frame}

\section{Regions}\subsection{}
\begin{frame}{Structural information}{Large scale resistivity with seismic structural information (Günther et al., 2011)}
\begin{columns}
\begin{column}[T]{0.2\textwidth}
Leine valley fault\\
\includegraphics[width=\columnwidth]{dctief/geologie}
\begin{block}{Large scale resistivity}
Dipole-Dipole-Experiment with high voltage generator (50\,A)
\end{block}
\begin{block}{}
\only<1>{classic result}%
\only<2>{interpretation of seismic reflections}%
\only<3>{incorporation into FE mesh}%
\only<4>{with structural information}%
\end{block}\vfill
\end{column}
\begin{column}[T]{0.8\textwidth}
\includegraphics<1>[width=\textwidth]{dctief/result-ohne}%
\includegraphics<2>[width=0.9\textwidth]{dctief/rxseismics}%
\includegraphics<3>[width=\textwidth]{dctief/structmesh}%
\includegraphics<4>[width=\textwidth]{dctief/result-mit}%
\end{column}
\end{columns}
\end{frame}

\begin{frame}{Structural information 3D}{ERT and GPR (Doetsch et al., 2011)}
\includegraphics[width=\columnwidth]{gravelbar/gpr}\\%
GPR image of a gravelly aquifer at Thur river
\end{frame}
\begin{frame}{Structural information 3D}{ERT and GPR (Doetsch et al., 2011)}
\begin{columns}
	\begin{column}{.17\textwidth}
		1 region\\ \vspace{8ex} 2 regions\\ \vspace{8ex} 3 regions
	\end{column}
	\begin{column}{.83\textwidth}
		\includegraphics[width=\columnwidth]{gravelbar/region-result}
	\end{column}
\end{columns}
\end{frame}

\begin{frame}{Parameter information}{Integration of direct push into ERT (Günther \& Rücker, xxxx)}
\only<1>{%
\begin{block}{Classic inversion result (Fit: $\chi^2=1$)\phantom{S}}\centering
\begin{columns}
\begin{column}[r]{0.77\columnwidth}
~~~\begin{overpic}[width=\columnwidth]{adert/adinv-borehole-normal.pdf}%
\put(0,0){\includegraphics[width=\columnwidth]{adert/adinv-borehole-normal-annot.pdf}}
\end{overpic}\\[5pt]
~~~~~~~~\includegraphics[width=0.98\columnwidth]{adert/adinv-borehole-cbar.pdf}%
\begin{itemize}
\item bedrock detected but too deep
\item clay layer above not detected
\end{itemize}
\end{column}
\!\!\!\!\!\begin{column}[r]{0.22\columnwidth}
\includegraphics[width=0.95\columnwidth]{adert/adinv-borehole-compare-1.pdf}
\end{column}
\end{columns}
\end{block}
}%\only<1>
\only<2>{%
\begin{block}{4 direct push regions\phantom{$\chi^2=1$}}\centering
\begin{columns}
\begin{column}[r]{0.77\columnwidth}
~~~\begin{overpic}[width=\columnwidth]{adert/adinv-borehole-regionstart.pdf}%
\put(0,0){\includegraphics[width=\columnwidth]{adert/adinv-borehole-region-annot.pdf}}
\end{overpic}\\[5pt]
~~~~~~~~\includegraphics[width=0.98\columnwidth]{adert/adinv-borehole-cbar.pdf}%
\begin{itemize}
\item individually controlled regions
\item coupling to main region
\end{itemize}
\end{column}
\!\!\!\!\!\begin{column}[r]{0.22\columnwidth}
\includegraphics[width=0.95\columnwidth]{adert/adinv-borehole-compare-2.pdf}
\end{column}
\end{columns}
\end{block}
}%\only<2>
\only<3>{%
\begin{block}{Inversion result with regions (Fit: $\chi^2=1$)\phantom{S}}\centering
\begin{columns}
\begin{column}[r]{0.77\columnwidth}
~~~\begin{overpic}[width=\columnwidth]{adert/adinv-borehole-region.pdf}%
\end{overpic}\\[5pt]
~~~~~~~~\includegraphics[width=0.98\columnwidth]{adert/adinv-borehole-cbar.pdf}%
\begin{itemize}
\item clear bedrock boundary in the whole model
\item inter-bedding clay$/$sand$/$clay imaged close to direct push
\end{itemize}
\end{column}
\!\!\!\!\!\begin{column}[r]{0.22\columnwidth}
\includegraphics[width=0.95\columnwidth]{adert/adinv-borehole-compare-3.pdf}
\end{column}
\end{columns}
\end{block}
}%\only<3>
\end{frame}

\begin{frame}{Structural+parameter information}{Prior region model (Coscia et al., 2011)}
\only<1>{\begin{columns}
	\begin{column}{.3\textwidth}
	\begin{block}{RECORD project}
		\begin{itemize}
			\item renaturation of river Thur
			\item aim: river-/ground water exchange
			\item electrodes in 18 installed boreholes
			\item geological \& technical regions
		\end{itemize}
	\end{block}
	\end{column}
	\begin{column}{.7\textwidth}
		\includegraphics[width=\columnwidth]{ilaria/domain}
	\end{column}
\end{columns}}%
\only<2->{\begin{overpic}[width=\columnwidth]{ilaria/result}%
		\only<3>{\put(0,0){\includegraphics[width=\columnwidth]{ilaria/gravel}}}
	\end{overpic}} %
\end{frame}


\begin{frame}[fragile]{Region options (REGIONFILE, TIMELAPSEREGIONFILE)}
start - starting value\\
cType - constraint type/order (0,1,2,10,20)\\
MC    - model control (strength)\\
zWeight - weight for smoothness in z-axis\\
trans   - transformation (linear, log, cot)\\
lBound/uBound - lower/upper resistivity bound\\
single  - whole region is one unknown\\
background - region is not part of inversion (prolongated)\\
fix - region has one fixed value (not part of inversion)

\footnotesize
\begin{verbatim}
#No start Ctype zWeight Trans lBound uBound
1   30    0     0.5     log   10     200
#No single start
2   1      100
#No background
0   1
#Inter-region
1 2 2.0
\end{verbatim}
\end{frame}

\begin{frame}[fragile]{Region example underwater ERT}

\begin{verbatim}
#No start Trans zWeight Ctype lBound uBound
2 100 log 0.1 1 10 1000
#No fix
3 22.5
#No background
1 1
\end{verbatim}
\end{frame}

\begin{frame}[fragile]{2nd exercise: Building the geometry (1)}
\begin{verbatim}
import matplotlib.pyplot as plt
import pygimli as pg

data = pg.DataContainer('feldungel.ohm')
pos = data.sensorPositions()
ex, ez = pg.x(pos), pg.z(pos)
plt.plot(ex, ez, 'x-')
\end{verbatim}
\end{frame}

\begin{frame}[fragile]{2nd exercise: Building the geometry (2)}
\begin{verbatim}
import matplotlib.pyplot as plt
import pygimli as pg

data = pg.DataContainer('feldungel.ohm')
pos = data.sensorPositions()
ex, ez = pg.x(pos), pg.z(pos)
poly = pg.meshtools.createParaMeshPLC(pos, paraDepth=20)
ax, _ = pg.show(poly)
ax.set_xlim(-10, 100)
ax.set_ylim(-30, 1)
\end{verbatim}
\end{frame}

\begin{frame}[fragile]{2nd exercise: Building the geometry (3)}
\begin{verbatim}
import matplotlib.pyplot as plt
import pygimli as pg

data = pg.DataContainer('feldungel.ohm')
pos = data.sensorPositions()
ex, ez = pg.x(pos), pg.z(pos)
poly = pg.meshtools.createParaMeshPLC(pos, paraDepth=20)
n1 = poly.findNearestNode(pg.RVector3(2, 	0))  # left shore
n2 = poly.findNearestNode(pg.RVector3(91.7452,	0))  # right
poly.createEdge(poly.node(n1), poly.node(n2), -1)
poly.addRegionMarker(pg.RVector3(50, -0.1), 3)
ax, _ = pg.show(poly)
ax.set_xlim(-10, 100)
ax.set_ylim(-30, 1)
\end{verbatim}
\end{frame}

\begin{frame}[fragile]{PLC (piecewise linear complex) of the lake example}
\includegraphics[width=\textwidth]{lake-poly}
\end{frame}


\begin{frame}[fragile]{2nd exercise: region-specific inversion}
    \begin{block}{Underwater example}
        \begin{itemize}
        	\item generate mesh \\
        	\verb|bert feldungel.cfg meshs|
            \item look at PLC\\
            \verb|bert feldungel.cfg showpoly|
            \item look at mesh and cell markers \\
            \verb|bert feldungel.cfg showmesh|\\
            \verb|pytripatch -d marker mesh/mesh.bms|
%            \item cfg File erzeugen und invertieren
            \item try different variants (as in Tutorial) 
            \begin{itemize}
                \item normal decoupled regions
                \item coupled regions (like without)
                \item water as single-parameter region 
                \item fixed water region
                \item range constraints 
            \end{itemize}
            \item inversion with ERT manager and setting in Python
        \end{itemize}
    \end{block}
\end{frame}

\section{Modelling}\subsection{}
\begin{frame}[fragile]{Simple 2d modelling example with pyGIMLi/pyBERT (1)}
Download script from \hyperlink{http://www.resistivity.net/download/simple.py}{here}
\begin{verbatim}
import pygimli as pg
import pygimli.meshtools as plc  # save space
import pybert as pb

# Create geometry definition for the modelling domain
world = plc.createWorld(start=[-50, 0], end=[50, -50],
                        layers=[-1, -5], worldMarker=True)
# Create some heterogeneous block
block = plc.createCircle(pos=[0, -3.], radius=1, 
                         marker=4, area=0.1)
# Merge geometry definition
geom = plc.mergePLC([world, block])
pg.show(geom)
\end{verbatim}    
\end{frame}
\begin{frame}[fragile]{Simple 2d modelling example with pyGIMLi/pyBERT (2)}
    \begin{verbatim}
# create measuring scheme (data container without data)
scheme = pb.createData(elecs=np.linspace(-10, 10, 21),
                       schemeName='dd')
for pos in scheme.sensorPositions():  # electrodes into geom
    geom.createNode(pos, marker=-99)  # historic convention
    geom.createNode(pos+pg.RVector3(0, -0.1))  # refine 10cm
mesh = plc.createMesh(geom)
pg.show(mesh)
rhomap = [[1,100.], [2, 50.], [3, 10.], [4, 100.]]
ert = pb.Resistivity()
data = ert.simulate(mesh, res=rhomap, scheme=scheme,
                    noiseLevel=2)  # add noise on the fly
data.save('simple.dat')
pb.show(data)
\end{verbatim}    
\end{frame}

\begin{frame}{Synthetic forward modelling}
    \begin{block}{Modelling examples in examples/modelling}
        \begin{itemize}
            \item Homogeneous half-space (TP) - Refinement, mesh quality
            \item layered half-space (TP, SP) - accuracy
            \item half sphere (SP) from Rücker et al. (2006)
            \item gallery profile (TP) from Rücker et al. (2006)
            \item 2d with topography along profile
            \item 3d with topography from a DEM
            \item several complete electrode (CEM) models (Rücker\&Günther 2011) and shunt electrode (SEM) models (Ronczka et al., 2015)
        \end{itemize}
    \end{block}
\end{frame}

\begin{frame}{PolyTools (dcfemlib) and 3D mesh generation}
    \begin{block}{Manipulation von PLC (piece-wise linear complex) in Files}
        \begin{tabbing}
            polyCreateWorld~~~ \= build a world (big box with boundary conditions)\\
            polyCreateCube \> make unit cube (or cylinder with -Z)\\
            polyScale \> scale (x,y,z)\\
            polyTranslate \> translation (x,y,z)\\
            polyRotate \> rotation (x,y,z)\\
            polyAddVIP \> new point(s), region marker (-R), hole (-H)\\
            polyRefineVIPS \> refine points by local point\\
            polyMerge \> merge two PLCs to one\\
            polyConvert \> convert PLC to VTK (-V) or STL (-S)
        \end{tabbing}
    \end{block}
    \begin{block}{Mesh generation with tetgen and conversion}
        tetgen -pazVAC -q1.2 input \# generates mesh.1.node/ele/face\\
        meshconvert -vVBDM -it -o output input.1 \# convert
    \end{block}
    Rule of thumb: total potential (TP) 0.1\,$a$ \& quadrat. refinement (-p)\\
    Secondary potential (SP) coarser, depending on contrast, mesh quality
\end{frame}


%\begin{frame}{3. Modellierung DC und SIP}
%    Inhalt...
%\end{frame}


\section{SIP}\subsection{}
\begin{frame}{IP modelling and inversion}
    \begin{block}{}
        modelling always complex-valued dc forward problem
    \end{block}
    \begin{block}{Frequency domain}
        \begin{itemize}
            \item linearized mapping from log$\rho_a$/log$\rho$
            \item subsequent inversion of real and imaginary part
            \item spectrally constrained inversion (G.\&Martin, 2016)
            \item fully complex inversion in progress
        \end{itemize}
    \end{block}
    \begin{block}{Time domain}
        \begin{itemize}
            \item linearized chargeability after Seigel (1959)
            \item chargeability-based reference inversion
        \end{itemize}
    \end{block}
\end{frame}

\begin{frame}[fragile]{SIP Managers}
    \begin{block}{The pyGIMLi SIP module}
        import routines, analysis, models, fitting, plotting
    \end{block}
    \begin{block}{The SIP spectrum manager}
        \begin{itemize}
            \item reads in SIP spectra
            \item remove high-frequency terms and fits spectra 
            \item various plotting functions
        \end{itemize}
    \end{block}
    \begin{block}{}
        \begin{verbatim}
from pygimli.physics.SIP import SIPSpectrum
sip = SIPSpectrum(‘example.txt’) # read data
sip.showData()  # as amplitude and phase
sip.showData(norm=True, KramersKronig=True) # normalized
sip.removeEM(epsilon=True)  # fit hf terms by epsilon
sip.fitColeCole()  # fit Cole-Cole model
sip.showAll(savePDF=True)
        \end{verbatim}
    \end{block}
\end{frame}

\begin{frame}[fragile]{SIP Managers}
    \begin{block}{The SIP data manager}
        \begin{itemize}
            \item reads in data (SIP256C/D, MPT) and create single f files
            \item generates multipage PDFs of spectra and pseudosections
            \item single and full constrained inversion
            \item fitting Cole-Cole models and various output of results
            %\item synthetic simulation based on Cole-Cole models
        \end{itemize}
    \end{block}
    \begin{block}{}
        \begin{verbatim}
from pybert.SIP import SIPdata
sip = SIPdata(‘example.res’) # SIP256C file
sip.generateSpectraPDF(maxdist=20)
sip.generateDataPDF(kmax=50000)
sip.removeEMTerms(Pelton=True)
sip.invertSingleFrequency(f=0.625)
sip.invertSimultaneous(maxF=200)
sip.fitColeColeModel(show=True)
sip.saveResults()            
        \end{verbatim}
    \end{block}    
\end{frame}

\begin{frame}[fragile]{Synthetic modelling with SIPdata manager}
\begin{block}{}
\begin{verbatim}
world = plc.createWorld(start=[-50, 0], end=[50, -50], layers=[-1, -5], worldMarker=1)
# Create some heterogeneous circle and merge with world
block = plc.createCircle(pos=[0, -3.], radius=1, marker=4, boundaryMarker=10, area=0.1)
geom = plc.mergePLC([world, block])
# place electrodes in the mesh and refine them
[geom.createNode((-10 + x, 0, 0), -99) for x in range(22)]
[geom.createNode((-10 + x, -0.1, 0)) for x in range(22)]
mesh = plc.createMesh(geom)
scheme = pb.createData(elecs=np.linspace(-10, 10, 21), schemeName='dd')
#                dumm, 1.S   2.S   3.S   Body
rhovec = np.array([0, 100.0, 50.0, 10.0, 100])  # ohm m
tauvec = np.array([0,   1e-3, 1e-3,  0.1,   1.0])  # s
mvec = np.array([0.001, 0.01, 0.001,  0.5,   0.5])  # - [0-1]
cvec = np.array([0.5,    0.5,  0.5,  0.5,   0.5])  # - [0-0.5]
frvec = [0.156, 0.312, 0.625, 1.25, 2.5, 5, 10, 20, 40, 80, 125, 250, 500, 1000]
sip = SIPdata(f=frvec, data=scheme)
sip.simulate(mesh, rhovec, tauvec, mvec, cvec)
sip.generateDataPDF(ipmax=100)
\end{verbatim}
\end{block}
\end{frame}

\section{Electrodes}\subsection{}
\begin{frame}{}
    \begin{block}{Electrodes can be}
        \begin{itemize}
            \item nodes (the default option)
            \item free positions (no topo, see example 2dxh)
            \item surfaces in the model (complete electrode model - CEM, R\&G2011)
            \item nodes coupled inline (shunt electrode model - SEM, Ronczka et al. 2015)
        \end{itemize}
    \end{block}
    \begin{block}{Implementation and use}
        all done in mesh generation $\Rightarrow$ automatic modelling and inversion
        \begin{itemize}
            \item point electrodes just associated by positions
            \item CEM electrodes are facets with boundary markers -10000, -10001 etc.\\
            (bash) toolbox for generating CEM electrodes\\
            Gmesh for generating CEM electrodes $\Rightarrow$ Florian
            \item SEM electrodes are nodes with node marker -10000, -10001, etc.
        \end{itemize}
    \end{block}
    \begin{block}{Examples}
        in examples/modelling/CEM and /examples/modelling/SEM
    \end{block}
\end{frame}

\begin{frame}{PEM vs. CEM (Rücker \& Günther 2011)}
    \begin{columns}
        \begin{column}{0.5\textwidth}
            \begin{block}{Mostly electrodes are considered points}
                \begin{itemize}
                    \item extension small compared to distance
                    \item contact impedances negligible (4-point measurements)
                \end{itemize}
                $\Rightarrow$ singular sources (discretization issue)
            \end{block}
        \end{column}
        \begin{column}{0.5\textwidth}
            \begin{block}{When do electrodes become finite?}
                \begin{itemize}
                    \item very small distances (model tanks)
                    \item plate electrodes (sealed ground)
                    \item capacitively coupled line electrodes
                    \item electrode rings in boreholes
                    \item borehole casings as electrodes
                \end{itemize}
            \end{block}
        \end{column}
    \end{columns}
    \vfill
    \only<1>{\includegraphics[width=\textwidth]{cem/schaltbild}}%
    \only<2>{\includegraphics[width=\textwidth]{cem/borehole}}%
\end{frame}


\begin{frame}{How to model long electrodes (Ronczka et al. 2015)}
    \begin{columns}
        \begin{column}{.6\textwidth}
            \includegraphics[width=\columnwidth]{samoleg/fig00}
        \end{column}
        \begin{column}{.4\textwidth}
            superposition not working (Zhang et al. 2014)\\
            Conductive Cell Model (Rucker et al. 2010)\\
            Complete Electrode Model (Günther \& Rücker 2011)\\
            $\Rightarrow$ both similar but sensi\-tive to electrode diameter\\
            Shunt Electrode Model (Ronczka et al. 2015): efficient for $d \ll l$
        \end{column}
    \end{columns}
\end{frame} 

\begin{frame}{CEM-Modelling examples in examples/modelling/CEM}
    \begin{itemize}
        \item steel casing as current electrode
        \item plate electrodes
        \item line electrodes
        \item borehole ring electrodes
        \item model tank electrode
        \item passives cable 
    \end{itemize}
\end{frame}

\begin{frame}{Vertical electrode chain Borkum (Rücker\&Günther,2011; Rücker,2011)}
    \begin{columns}
        \begin{column}{.4\textwidth}
            electrodes are rings (3D forward problem with CEM)\\
            \includegraphics[width=\columnwidth]{electrode/vec-prim3}\\
            inverse problem is 1\only<1>{D\\~\strut}%
            \only<2>{.5D (near\&far resistivity)\strut}
        \end{column}
        \begin{column}{.6\textwidth}
            \begin{overpic}[width=\columnwidth]{electrode/2d1dresult}
                \only<2>{\put(41,-14){\includegraphics[width=0.55\columnwidth]{electrode/nearfar}}}%
            \end{overpic}
        \end{column}
    \end{columns}
\end{frame}



% % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % %
\section{Timelapse}\subsection{}
\begin{frame}{Timelapse inversion}
    \begin{block}{Timelapse inversion}
        \begin{itemize}
            \item selection from numerous approaches (schemes, constraints, error models)
            \item separate inversion yields artefacts, ratio inversion looses amplitude
            \item reference (difference) inversion combines both
        \end{itemize}
    \end{block}
    
    \begin{columns}[T]
        \begin{column}{0.5\textwidth}
            \includegraphics[width=\columnwidth]{ulla/brilliantblue}\\
            Verification with brilliant blue (C. Ganz (LUH) \& U. Noell (BGR))%%\\[3ex]
        \end{column}
        \begin{column}{0.5\textwidth}
            ~\\[2ex]%\visible<2>{%
            \includegraphics[width=\columnwidth]{ulla/bert-result}%}
        \end{column}
    \end{columns}
\end{frame}

\begin{frame}{Timelapse inversion schemes}
    \begin{block}<+->{Schemes}
        \begin{itemize}
            \item individual inversion of single time frames: $\m^n=\{\log\rho(t=t_n)\}$
            \item<+-> inversion of data differences or ratios:
            $\d^n=\{\rho_a^n/\rho_a^0$\}, $\m^n=\{\rho^n/\rho^0\}$
            \item<+-> inversion with starting or reference model from $t=0$ \only<+->{or $t_{n-1}$}
            \item<+-> difference inv. (LaBrecque) corrects misfit at $t=0$ %
            \only<.>{$\d^n=\{\rho_a^n/\rho_a^0\} \f(\m^0)$}
            \only<+->{or $t_{n-1}$} 
            \item<+-> inversion fully discretized in time (4D ERT)
        \end{itemize}
    \end{block}
    \begin{block}<+->{Regularization of model and model changes}
        \begin{itemize}
            \item 1st order, 2nd order smoothness, minimum distance or mix
        \end{itemize}
    \end{block}
    \begin{block}{}
        \[ \big\| \W_d(\d^n - \f(\m^n) 
        \visible<5->{-\d^{\only<5>{0~~~}\only<6->{n-1}}+\f(\m^{\only<5>{0~~~}\only<6->{n-1}})} 
        ) \big\|^2 + \lambda 
        \| \W_m (\m^n \visible<3->{- \m^{\only<3,5>{0~~~}\only<4,6->{n-1}}} ) \|^2 \rightarrow\min \]
    \end{block}	
\end{frame}

\begin{frame}{Timelapse options}
    \begin{description}
        \item[TIMESTEPS] - file holding the individual data file for each frame
        \item[LAMBDATIMELAPSE] - global regularization strength for timelapse
        \item[TIMELAPSECONSTRAINT] - regularization order (global)
        \item[TIMELAPSEREGIONFILE] - region file for time steps
        \item[TIMELAPSESTEPMODEL] - use preceding frame as reference (else first)
        \item[TIMELAPSEREMOVEMISFIT] - apply misfit from reference (LaBrecque difference inversion)
        \item[TIMELAPSEABSMODEL] - constrain absolute model instead of difference
        \item[FASTTIMELAPSE] - do not compute Jacobian any more 
        \item[RATIOSTEP] - use only a ratio step as in BERT 1
    \end{description}
\end{frame}

\begin{frame}{Hill-slope infiltration (group Prof. Kleber, TU Dresden)}
    relative resistivity change after/before rainfall event
    \includegraphics[width=\columnwidth]{mulda/mulda-bert1diff}\\
    artifacts from imaging
\end{frame}


\begin{frame}{Hill-slope infiltration (Hübner et al., 201x)}
    Problem-adapted scheme: partition in regions:\\
    {\color{blue}background} - {\color{cyan}aquifer} - 
    {\color[rgb]{0.5,0.5,0}vadose zone} - {\color[rgb]{0.8,0.1,0.1}bedrock}\\
    \only<1>{Regions\\
        \includegraphics[width=\columnwidth]{mulda/regions}\vspace{3ex}}%
    \only<2>{Regions decoupled\\
        \includegraphics[width=\columnwidth]{mulda/result0}}%
    \only<3>{No changes in bedrock, only smooth changes in aquifer\\
        \includegraphics[width=\columnwidth]{mulda/result1}}%
    \only<4>{No changes in bedrock, only smooth changes in aquifer\\
        \includegraphics[width=0.9767\columnwidth]{mulda/ratio-E}\vspace{2ex}}%
\end{frame}

\begin{frame}{ALERT data (Kuras et al., 2009)}
    \begin{overpic}[width=0.45\textwidth]{alert/c1/ratio-6}
        \put(105,30){C1}
    \end{overpic}\hfill 
    \includegraphics[width=0.45\textwidth]{alert/c1/ratio-18}\\
    \begin{overpic}[width=0.45\textwidth]{alert/c2/ratio-6}
        \put(105,30){C2}
    \end{overpic}\hfill 
    \includegraphics[width=0.45\textwidth]{alert/c2/ratio-18}\\
    \begin{overpic}[width=0.45\textwidth]{alert/c20/ratio-6}
        \put(105,30){C20}
    \end{overpic}\hfill 
    \includegraphics[width=0.45\textwidth]{alert/c20/ratio-18}\\
    \centerline{\includegraphics[width=0.5\textwidth]{alert/b2r02-5}} 
\end{frame}

\begin{frame}{4. Übung}
    \begin{block}{Aufgaben mit dem 2dxh Datensatz}
        \begin{itemize}
            \item gehen Sie in das Verzeichnis examples/inversion/2dxh
            \item erzeugen Sie ein schönes statisches Ergebnis durch Variation von Netz (z.B. GRID) und  Regularisierung 
            \item packen Sie das zip-File aus und tragen Sie die TIMESTEPS Datei in das cfg ein (Tipp: zunächst nur wenige Zeitschritte zum testen)
            \item variieren Sie verschiedene Timelapse-Optionen und vergleichen Sie die Ergebnisse (siehe BERT Tutorial)
        \end{itemize}
    \end{block}
\end{frame}



% % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % %
\section{Anhang}\subsection{}
\begin{frame}{Outlook for future development}
    \begin{block}{}
        (mostly integrate existing scripts into pyGIMLi/BERT)
        \begin{itemize}
            \item geostatistical regularization (correlation lengths and dip)
            \item reciprocal data analysis for determining error model
            \item Data browser (picker) with timelapse facility
            %automated 
            \item more HowTo examples as ready options (which?)
            \item full sphinx documentation on resistivity.net
            %(or integration into pyGIMLi?)
            %switch to Python 3.5
            \item IP inversion directly to Cole-Cole parameters
            \item spectrale TDIP inversion
        \end{itemize}
    \end{block}
\end{frame}

%\section{pyGIMLi}\subsection{}
\begin{frame}{GIMLi - Geophysical Inversion and Modelling Library}{Architektur}
    \includegraphics[width=\textwidth]{gimli/gimliblock}
    \vspace{-2ex}
    \begin{columns}
        \begin{column}[T]{0.5\textwidth}
            \begin{block}<+->{Basic concept}
                \begin{itemize}
                    \item physics-free minimization
                    \item generalized regularization
                    \item controlled by regions
                    \item large number of methods
                \end{itemize}
            \end{block}
        \end{column}
        \begin{column}[T]{0.5\textwidth}
            \begin{block}<+->{Transformation functions}
                \begin{itemize}
                    \item valid range by log/tan functions
                    \item petrophysical relations
                    \item combination, e.g. $\phi$=Archie($\rho$) \&
                    $m=\log(\phi-\phi_l)-\log(\phi_u-\phi)$ 
                \end{itemize}
            \end{block}
        \end{column}
    \end{columns}
\end{frame}

\begin{frame}{GIMLi: already included forward operators}
    \begin{itemize}
        \item DC1dModelling/DC1dRhoModelling: 1D-DC with Block or Smooth discretisatioun
        \item FDEM1dModelling, FDEM1dRhoModelling: frequency EM block/smooth
        \item MT1dModelling, MT1dRhoModelling: magnetotellurics
        \item MRS1dBlockModelling, MRS1dSmoothModelling: Magnetic Resonance Sounding
        \item TTDijsktraModelling: first arrival travel times (refraction)
        \item Gravimetry: Gravimetry in 2D und 3D
        \item EllipticPDE: Solution of Helmholtz equations in 1D/2D/3D
        \item ParabolicPDE: Implicit solution of parabolic PDEs
        \item Polynom-Fit, Harmonic Filtering, Linear Abstracts etc.
    \end{itemize}
    ... TEM1D, MRT 2D/3D running
\end{frame}

\begin{frame}{Python styles}
%\begin{lstlisting}[language=Python]
\#from pylab import *   \# for Matlab freaks - better not!\\
import numpy as np\\
import matplotlib.pyplot as plt

x = np.arange(5)\\
plt.plot(x, x**2, 'rx-')  \# just like matlab \\[1ex]
plt.savefig('result.pdf')\\[1ex]

\# better using the objects themselves

fig, ax = plt.subplots()\\
ax.plot(x, x**2, 'rx')\\
ax.set\_any\_property(...)  \# very flexible\\
fig.savefig('result.pdf')\\[1ex]

import pygimli as pg\\
import pybert as pb
%\end{lstlisting} 
\end{frame}

\begin{frame}{pyGIMLi Grundkonstrukte}
pg.RVector	- real vector (compatible with numpy.array)
  (also CVector, IVector, BVector)
  
pg.RMatrix	- real, dense Matrix (also different sparse matrices, block matrices etc.)

pg.RTrans/RTransLog/RTransLogLU,RTransCotLU,... - real transformations

pg.Region/RegionManager	- property-specific region for modelling/inversion, adminstrator

pg.RInversion	- real inversion (so far no other types)

pg.ModellingBase	- base modelling class to be derived from
\end{frame}


%\section{Anhang}\subsection{}
\begin{frame}{Links}
\footnotesize
\begin{block}{pyGIMLi website and documentation}
	\url{http://pygimli.org}
\end{block}
\begin{block}{BERT Tutorial with User stories}
BERT        \url{http://www.resistivity.net/download/bert-tutorial.pdf}\\
%GIMLi-C++   \url{http://www.resistivity.net/download/gimli-tutorial.pdf}
\end{block}
\begin{block}{Project pages with source code, issue tracker etc.}
GIMLi       \url{https://github.com/gimli-org/gimli}\\
BERT        \url{https://gitlab.com/resistivity-net/bert}\\
\end{block}
\begin{block}{Binaries}
Windows 64bit with Python 3.5 (64bit), e.g. WinPython 3.5.3.0: \url{http://www.resistivity.net/download/setup-bert2.1.3win64py35.exe}
\url{http://www.resistivity.net/download/setup-bert2.1.2win64py35.exe}
\url{http://www.resistivity.net/download/setup-bert2.1.1win64py34.exe}
\end{block}
\end{frame}	
 
\begin{frame}{References}{}
\footnotesize
\begin{block}{Methodology Papers}
Rücker et al. (2006): 3-D modeling and inversion of DC resistivity data incorporating topography - Part I: Modeling. - Geophys. J. Int., 166, 495-505.

Günther et al. (2006): 3-D modeling and inversion of DC resistivity data incorporating topography - Part II: Inversion. - Geophys. J. Int. 166, 506-517.

Rücker, C. (2011): Advanced Electrical Resistivity Modelling and Inversion using Unstructured Discretization. PhD thesis, University of Leipzig. (Advanced inversion)

Rücker\&Günther (2011): The simulation of finite ERT electrodes using the complete electrode model. - Geophysics  76 (4), F227-F238. (CEM electrodes)

%Rücker\&Günther: Advanced ERT using a region-based regularization approach. - under review.
Ronczka et al. (2015): Numerical study of long electrode electric resistivity tomography
– Accuracy, sensitivity and resolution. Geophysics, 80(6), E317-328. (long electrodes)

Günther\&Martin (2016): Spectral two-dimensional inversion of frequency-domain induced polarisation data from a mining slag heap. J. of Appl. Geoph., doi:10.1016/j.jappgeo.2016.01.008. (SIP)
\end{block}

\end{frame}

\begin{frame}{References}{Applications with methodical contribution}
\scriptsize
Doetsch et al. (2010): The borehole-fluid effect in electrical resistivity imaging. Geophysics, 75 (4), F107-F114. (discretization of boreholes and control of their fluids)
	
Flechsig et al. (2010): Geoelectrical Investigations in the Cheb Basin/W-Bohemia: An Approach to Evaluate the Near-Surface conductivity structure. Stud. Geophys. Geod., 54 , 417-437. (Inversion with fixed regions)
	
Udphuay et al. (2011): Three-dimensional resistivity tomography 1 in extreme coastal terrain amidst dense cultural signals: application to cliff stability assessment at the historic D-Day site. Geophys. J. Int., 185 , 201-220. (Mesh building for 3D with topography, reciprocal error models)

Coscia et al. (2011): 3D crosshole apparent resistivity static inversion and monitoring of a coupled river-aquifer system. Geophysics, 76 (2), G49-59.\\
	(complicated region geometry, anisotropic regularization on unstructured meshs)
	
Doetsch et al. (2012): Constraining 3-D electrical resistance tomography with GPR reflection data for improved aquifer characterization. Journal of Applied Geophysics, 78 , 68-76. (3D structural constraints)
	
Martin \& Günther (2013): Complex resistivity tomography (CRT) for fungus detection on standing oak trees. European Journal of Forest Research, 132 (5), 1-12. (IP phase inversion)
\end{frame}	

\begin{frame}{References}{BERT Applications}
\begin{block}{Pure applications}
    Göcke et al. (2008), Heincke et al. (2009), Bock et al. (2010), Doetsch et al. (2010,2011), Flechsig et al. (2010), Clement et al. (2010), Udphuay et al. (2011), Coscia et al. (2011,  2012), Garre et al. (2010, 2011, 2012), Bergmann et al. (2012), Schmidt-Hattenberger et al. (2012), Bechtold et al. (2012), Beff et al. (2013), Martin\&Günther (2013), Bazin\&Pfaffhuber (2013), Priegnitz et al. (2013), Leslie\&Heinse (2013), Clement et al. (2014), Audebert et al. (2014a,b), Flechsig et al. (2015), Wagner et al.  (2015), Persson et al. (2015), Hübner et al. (2015), Ronczka et al. (2015a,b), Falcon-Suarez et al. (2016), Doetsch et al. (2016), Gance et al. (2016), Schmidt-Hattenberger et al. (2016), Bergmann et al. (2016)
\end{block}
\end{frame}	

\begin{frame}{Regularisation in GIMLi \& BERT}
    \begin{block}{Generalized least squares minimization}
        $$
        ||\mathbf{C_d^{-1}}(\mathbf{d}-\mathbf{f}(\mathbf{m}))||_2^2 +
        %||\textbf{W}^{\mathrm{b}}\mathbf{C}\textbf{W}^{\mathrm{m}}(\mathbf{m}-\mathbf{m}_0) ||_2^2\rightarrow \text{min}
        \lambda||\mathbf{C_m^{-1}}(\mathbf{m}-\mathbf{m}^\text{ref})||_2^2\rightarrow \text{min}
        $$
        {\small $\mathbf{d}$ -- data,
            $\mathbf{f}$ -- forward operator,
            $\mathbf{m}$ -- model,
            $\mathbf{C_d} = \text{diag}(\epsilon_j^2)$ -- data covariance,\\
            $\lambda$ -- global regularization, $\mathbf{C_m}$ -- model covariance\\
            $\mathbf{C_m^{-1}}=\mathbf{w}^{\text{s}}\mathbf{C}\mathbf{w}^{\text{m}}$ -- with constraint matrix (e.g. smoothness) $\mathbf{C}$ \\
            $\textbf{w}^{\mathrm{s}} = \text{diag}(w_j^{\mathrm{s}})$ structural weights;
            $\textbf{w}^{\mathrm{m}} = \text{diag}(w_j^{\mathrm{m}})$ model weights
        }%\small
    \end{block}
    %
    \begin{block}{Mini example for $\mathbf{C}$}
        \begin{columns}
            ~~~~~~~~~~~~\begin{column}{0.35\columnwidth}
                \includegraphics[clipping,width=0.8\columnwidth]{gimli/MiniModel-3.pdf} 
            \end{column}
            \hfill
            \begin{column}{0.5\columnwidth}\centering
                {\footnotesize
                    \ \\
                    ~~~~~6 parameter cells\\[-15pt] %und 6 Parametergrenzen
                    $$
                    \mathbf{C}=
                    \left(\begin{matrix}
                    -1 & \phantom{-}1 & \phantom{-}0 & \phantom{-}0 & \phantom{-}0 & \phantom{-}0\\
                    \phantom{-}0 &           -1 & \phantom{-}0 & \phantom{-}1 & \phantom{-}0 & \phantom{-}0\\
                    \phantom{-}0 &           -1 & \phantom{-}1 & \phantom{-}0 & \phantom{-}0 & \phantom{-}0\\
                    \phantom{-}0 & \phantom{-}0 &           -1 & \phantom{-}0 & \phantom{-}1 & \phantom{-}0\\
                    \phantom{-}0 & \phantom{-}0 & \phantom{-}0 &           -1 & \phantom{-}0 & \phantom{-}1\\
                    \phantom{-}0 & \phantom{-}0 & \phantom{-}0 & \phantom{-}0 &          - 1 & \phantom{-}1
                    \end{matrix}\right)
                    $$
                }
            \end{column}
            \begin{column}{0.03\columnwidth}
                \includegraphics[clipping,scale=0.47]{gimli/tmp.pdf} 
            \end{column}~~~~~~~~~
        \end{columns}
    \end{block}
\end{frame} 

\begin{frame}{GIMLi: Regularization and region approach}
    \begin{columns}[T]
        \begin{column}{0.5\textwidth}
            \begin{block}{Generalized minimization}
                \begin{itemize}
                    \item weighting factors for each model boundary and cell
                    \item geometry-dependent regularisation
                    \item cell association to regions
                \end{itemize}
            \end{block}
            \begin{block}{Region properties}
                \begin{itemize}
                    \item parameter boundaries
                    \item constraint type
                    \item (anisotropic) smoothness
                    \item time-lapse behaviour
                \end{itemize}
                + constraints between regions
            \end{block}
        \end{column}
        \begin{column}{0.5\textwidth}
            Subsurface discretization\\[2ex]
            \only<1>{\includegraphics[width=\columnwidth]{gimli/MiniModel-3}}%
            \only<2>{\includegraphics[width=\columnwidth]{gimli/MiniModel-ws-1}}%
            \only<3>{\includegraphics[width=\columnwidth]{gimli/MiniModel-ws-z}}%
            \only<4>{\includegraphics[width=\columnwidth]{gimli/MiniModel-ws-0}}%
            \only<5>{\includegraphics[width=\columnwidth]{gimli/MiniModel-region}}%
            \only<6>{\includegraphics[width=\columnwidth]{gimli/MiniModel-cluster}}%
            \\
            \only<1>{model cells and boundaries}%
            \only<2>{classic smoothness}%
            \only<3>{anisotropic smoothness}%
            \only<4>{decoupling of sub-parts}%
            \only<5>{disjunct regions}%
            \only<6>{clustering of regions}%
        \end{column}
    \end{columns}
\end{frame}

\begin{frame}{Differences between BERT 1 and BERT 2}
    \begin{itemize}
        \item more efficient due to better implementation, multi-Core threading
        \item more element types except triangles and tetrahedra:\\
        (skewed) rectangles \& hexahedra, triangle prisms, pyramids, mix
        \item more regularisation types: 0th order (min length), 1st derivative, 2nd derivative, mix of 0+1, 0+2
        \item different types of electrodes: nodes, surfaces (CEM) or free positions
        \item easier data filtering (RMIN/RMAX,IPMAX,KMAX,ERRMAX)
        \item improved IP Inversion (linearised imaginary parts)
        \item consequent and flexible Timelapse inversion
        \item better visualisation and scripting thanks to Python
        \item more flexible control of regions, hybrid Inversion (e.g. 1D Inv., 3D Fwd.)
    \end{itemize}
\end{frame}



\begin{frame}{Modelling with dcmod - options}
    \begin{block}{dcmod [options] mesh}
        \begin{tabbing}
            ~~~~~~~~~~~~~~~~~~~~~ \= ~ \kill
            -v \> verbose Output\\
            -s sheme \> use scheme (otherwise potential matrix)\\
            -S \> secondary potential (SP) else total potential (TP)\\
            -x primpot \> load primary potentials from file\\
            
            -a rho.map \> Mapping marker$\Rightarrow$resistivity\\
            -1 \> constant 1\,$\Omega$m (primary potential)\\
            
            -m outmesh \> interpolate results to outmesh\\
            -R \> outmesh is further refined (BERT default)\\
            
            -o outname \> ouput filename
        \end{tabbing}
    \end{block}
    Example infiltration:
    
    dcmod -v -S -a rho.map -o num.ohm -s data.shm mesh.bms
\end{frame}

\begin{frame}{Data manipulation with dcedit - options}
    \begin{block}{dcedit [Optionen] Datenfile}
        \begin{tabbing}
            ~~~~~~~~~~~~~~~~~~~~~ \= ~ \kill
            -v \> verbose output\\
            -S \> statistics\\
            -E \> estimate error\\
            -e \> relative error level in \%\\
            -u dvolt \> voltage error\\
            -N \> noisify data with error\\
            -c corrfile \> load geometric factor or primpot from corrfile\\
            -B \> generate BERT inversion file (with $\rho_a$, $k$ \& $\epsilon$)\\
            -o outname \> output filename\\
            -f format \> output format string\\
            --filter=rule \> filter (delete) with rule field OP value\\
            -D \> downweight with error instead of delete
        \end{tabbing}
    \end{block}
    --filter='A=23' filters data where A=23 \\
    --filter='rhoa<1' filters data with $\rho_a$<1\,$\Omega$m\\
    --filter='k>5000:A' filters geometric factors >5000 or <-5000 
\end{frame}



%%%%%%%%%%%%%%%%%%% commented!!!! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{comment}
\begin{frame}[fragile]{Beispiel Infiltration von Ulla}
\footnotesize %
\begin{verbatim}
mkdir -p mesh
SIZE=30 # Groesse der Box
DIA=0.4 # Durchmesser des Zylinders
%#for DEP in `seq 0.2 0.2 1.5`;do
DEP=0.2
echo $DEP
# generiere PLC
polyCreateWorld -v -x $SIZE -y $SIZE -z $SIZE -m 1 mesh/world
polyCreateCube -v -m 2 -s 16 -a 0.001 -Z mesh/cyl # 8-eck Zylinder um 0/0/0
polyTranslate -z -0.5 mesh/cyl # Deckel bei z=0
polyScale -x $DIA -y $DIA -z $DEP mesh/cyl
polyMerge mesh/world mesh/cyl mesh/mesh
polyConvert -V -o mesh/meshPoly mesh/mesh
# Elektroden extrahieren und einbauen
NELH=`head -n1 $datei`
echo $NELH
head -n $[NELH + 2] < $datei|tail -n $NELH > $datei.xyz
polyAddVIP -m -99 -f $datei.xyz mesh/mesh
# Netzbau
tetgen -pazVAC -q1.2 mesh/mesh # generiert mesh.1.node/ele/face
meshconvert -vVBDM -it -o mesh/mesh mesh/mesh.1 # konvertieren
# Widerstandsverteilung
echo 1 300 > rho.map
echo 2 10 >> rho.map
# rechnen und konvertieren
for datei in *.shm
do          
# mit singularity removal, Wid.-vert. Schema
dcmod -v -S -a rho.map -o num.ohm -s $datei mesh/mesh.bms
dcedit -v -N -e3 -S -B -o ${datei%.shm}-$DEP.dat num.ohm
# Statistik, BERT-fertiges Format
done
\end{verbatim}
\end{frame}

\subsection{Some challenges}
\begin{frame}{One challenge: Strong topography}{Point du Hoc, Normandy (Udphuay et al., 2011)}
\centering\begin{overpic}[width=\columnwidth]{pdh/topview}
\only<1>{\put(65,23){\includegraphics[width=0.35\textwidth]{pdh/location}}}
\only<2->{\put(70,10){\includegraphics[width=0.3\textwidth]{pdh/seepage}}}
\end{overpic}
\end{frame}

\begin{frame}{One challenge: Strong topography}{Point du Hoc, Normandie (Udphuay et al., 2011)}{%
\only<1>{Delaunay surface mesh, electrodes (red) and polygons (green)}%
\only<2>{Resulting mesh without polygones}%
\only<3>{Resulting mesh with polygones}%
\only<4>{Inversion result}%
\strut}%
\begin{center}%
\includegraphics<1>[width=0.85\columnwidth]{pdh/meshinput}%
\includegraphics<2>[width=0.9\columnwidth]{pdh/withoutpoly}%
\includegraphics<3>[width=0.9\columnwidth]{pdh/withpoly}%
\includegraphics<4>[width=0.6\columnwidth]{pdh/result-1}%
\end{center}
\end{frame} 

\begin{frame}{A complex, but typical example (Coscia et al., 2011)}
\begin{overpic}[width=0.85\textwidth]{ilaria/domain}
\put(100,90){crosswell ERT}
\put(100,85){experiment}
\put(100,75){3d domain with}
\put(100,70){topography}
\put(20,95){river}
\put(100,55){known geology}
\put(100,45){boreholes with}
\put(100,40){electrodes}
\put(100,30){target: temporal}
\put(100,25){changes in}
\put(100,20){ aquifer}
\end{overpic}
\end{frame}




\begin{frame}{Regularisation in GIMLi \& BERT}
\begin{block}{Generalized least squares minimization}
$$
||\mathbf{C_d^{-1}}(\mathbf{d}-\mathbf{f}(\mathbf{m}))||_2^2 +
%||\textbf{W}^{\mathrm{b}}\mathbf{C}\textbf{W}^{\mathrm{m}}(\mathbf{m}-\mathbf{m}_0) ||_2^2\rightarrow \text{min}
\lambda||\mathbf{C_m^{-1}}\mathbf{m}-\mathbf{h}||_2^2\rightarrow \text{min}
$$
{\small $\mathbf{d}$ -- data,
$\mathbf{f}$ -- forward operator,
$\mathbf{m}$ -- model,
$\mathbf{C_d} = \text{diag}(\epsilon_j^2)$ -- data covariance,\\
$\lambda$ -- global regularization, $\mathbf{C_m}$ -- model covariance\\
$\mathbf{C_m^{-1}}=\mathbf{w}^{\text{s}}\mathbf{C}\mathbf{w}^{\text{m}}$ -- with constraint matrix (e.g. smoothness) $\mathbf{C}$ \\
$\textbf{w}^{\mathrm{s}} = \text{diag}(w_j^{\mathrm{s}})$ structural weights;
$\textbf{w}^{\mathrm{m}} = \text{diag}(w_j^{\mathrm{m}})$ model weights
}%\small
\end{block}
%
\begin{block}{Mini example for $\mathbf{C}$}
\begin{columns}
~~~~~~~~~~~~\begin{column}{0.35\columnwidth}
\includegraphics[clipping,width=0.8\columnwidth]{gimli/MiniModel-3.pdf} 
\end{column}
\hfill
\begin{column}{0.5\columnwidth}\centering
{\footnotesize
\ \\
~~~~~6 parameter cells\\[-15pt] %und 6 Parametergrenzen
$$
\mathbf{C}=
\left(\begin{matrix}
	  -1 & \phantom{-}1 & \phantom{-}0 & \phantom{-}0 & \phantom{-}0 & \phantom{-}0\\
\phantom{-}0 &           -1 & \phantom{-}0 & \phantom{-}1 & \phantom{-}0 & \phantom{-}0\\
\phantom{-}0 &           -1 & \phantom{-}1 & \phantom{-}0 & \phantom{-}0 & \phantom{-}0\\
\phantom{-}0 & \phantom{-}0 &           -1 & \phantom{-}0 & \phantom{-}1 & \phantom{-}0\\
\phantom{-}0 & \phantom{-}0 & \phantom{-}0 &           -1 & \phantom{-}0 & \phantom{-}1\\
\phantom{-}0 & \phantom{-}0 & \phantom{-}0 & \phantom{-}0 &          - 1 & \phantom{-}1
\end{matrix}\right)
$$
}
\end{column}
\begin{column}{0.03\columnwidth}
\includegraphics[clipping,scale=0.47]{gimli/tmp.pdf} 
\end{column}~~~~~~~~~
\end{columns}
\end{block}
\end{frame} 

\begin{frame}{GIMLi: Regularization and region approach}
\begin{columns}[T]
\begin{column}{0.5\textwidth}
	\begin{block}{Generalized minimization}
		\begin{itemize}
			\item weighting factors for each model boundary and cell
			\item geometry-dependent regularisation
			\item cell association to regions
		\end{itemize}
		\end{block}
		\begin{block}{Region properties}
		\begin{itemize}
			\item parameter boundaries
			\item constraint type
			\item (anisotropic) smoothness
			\item time-lapse behaviour
		\end{itemize}
		+ constraints between regions
	\end{block}
\end{column}
\begin{column}{0.5\textwidth}
Subsurface discretization\\[2ex]
	\only<1>{\includegraphics[width=\columnwidth]{gimli/MiniModel-3}}%
	\only<2>{\includegraphics[width=\columnwidth]{gimli/MiniModel-ws-1}}%
	\only<3>{\includegraphics[width=\columnwidth]{gimli/MiniModel-ws-z}}%
	\only<4>{\includegraphics[width=\columnwidth]{gimli/MiniModel-ws-0}}%
	\only<5>{\includegraphics[width=\columnwidth]{gimli/MiniModel-region}}%
	\only<6>{\includegraphics[width=\columnwidth]{gimli/MiniModel-cluster}}%
\\
	\only<1>{model cells and boundaries}%
	\only<2>{classic smoothness}%
	\only<3>{anisotropic smoothness}%
	\only<4>{decoupling of sub-parts}%
	\only<5>{disjunct regions}%
	\only<6>{clustering of regions}%
\end{column}
\end{columns}
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%% DATA INTEGRATION %%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Model reduction}
\begin{frame}{Vertical electrode chain Borkum (Rücker\&Günther,2011, Günther\&Rücker,201x)}
\begin{columns}
		\begin{column}{.4\textwidth}
		electrodes are rings (3D forward problem with CEM)\\
		\includegraphics[width=\columnwidth]{electrode/vec-prim3}\\
		inverse problem is 1\only<1>{D\\~\strut}%
		\only<2>{.5D (near\&far resistivity)\strut}
		\end{column}
		\begin{column}{.6\textwidth}
		\begin{overpic}[width=\columnwidth]{electrode/2d1dresult}
		\only<2>{\put(41,-14){\includegraphics[width=0.55\columnwidth]{electrode/nearfar}}}%
		\end{overpic}
		\end{column}
	\end{columns}
\end{frame}


\subsection{Structural information}
\begin{frame}{Structural information}{Large scale resistivity with seismic structural information (Günther et al., 2011)}
\begin{columns}
\begin{column}[T]{0.2\textwidth}
Leine valley fault\\
\includegraphics[width=\columnwidth]{dctief/geologie}
\begin{block}{Large scale resistivity}
Dipole-Dipole-Experiment with high voltage generator (50\,A)
\end{block}
\begin{block}{}
\only<1>{classic result}%
\only<2>{interpretation of seismic reflections}%
\only<3>{incorporation into FE mesh}%
\only<4>{with structural information}%
\end{block}\vfill
\end{column}
\begin{column}[T]{0.8\textwidth}
\includegraphics<1>[width=\textwidth]{dctief/result-ohne}%
\includegraphics<2>[width=0.9\textwidth]{dctief/rxseismics}%
\includegraphics<3>[width=\textwidth]{dctief/structmesh}%
\includegraphics<4>[width=\textwidth]{dctief/result-mit}%
\end{column}
\end{columns}
\end{frame}

\begin{frame}{Structural information}{ERT and GPR (Doetsch et al., 2011)}
	\only<1>{\includegraphics[width=\columnwidth]{gravelbar/site1}}%
	\only<2>{\includegraphics[width=\columnwidth]{gravelbar/site2}}%
	\only<3>{\includegraphics[width=\columnwidth]{gravelbar/gpr}}%
\end{frame}

\begin{frame}{Structural information}{ERT and GPR (Doetsch et al., 2011)}
\only<1>{\includegraphics[width=\columnwidth]{gravelbar/gpr}\\%
GPR image of a gravelly aquifer at Thur river}%
\only<2>{\begin{columns}
		\begin{column}{.17\textwidth}
			1 region\\ \vspace{8ex} 2 regions\\ \vspace{8ex} 3 regions
		\end{column}
		\begin{column}{.83\textwidth}
			\includegraphics[width=\columnwidth]{gravelbar/region-result}
		\end{column}
	\end{columns}}
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Parameter information}
\begin{frame}{Parameter information}{Integration of direct push into ERT (Günther \& Rücker, xxxx)}
\only<1>{%
\begin{block}{Classic inversion result (Fit: $\chi^2=1$)\phantom{S}}\centering
\begin{columns}
\begin{column}[r]{0.77\columnwidth}
~~~\begin{overpic}[width=\columnwidth]{adert/adinv-borehole-normal.pdf}%
\put(0,0){\includegraphics[width=\columnwidth]{adert/adinv-borehole-normal-annot.pdf}}
\end{overpic}\\[5pt]
~~~~~~~~\includegraphics[width=0.98\columnwidth]{adert/adinv-borehole-cbar.pdf}%
\begin{itemize}
\item bedrock detected but too deep
\item clay layer above not detected
\end{itemize}
\end{column}
\!\!\!\!\!\begin{column}[r]{0.22\columnwidth}
\includegraphics[width=0.95\columnwidth]{adert/adinv-borehole-compare-1.pdf}
\end{column}
\end{columns}
\end{block}
}%\only<1>
\only<2>{%
\begin{block}{4 direct push regions\phantom{$\chi^2=1$}}\centering
\begin{columns}
\begin{column}[r]{0.77\columnwidth}
~~~\begin{overpic}[width=\columnwidth]{adert/adinv-borehole-regionstart.pdf}%
\put(0,0){\includegraphics[width=\columnwidth]{adert/adinv-borehole-region-annot.pdf}}
\end{overpic}\\[5pt]
~~~~~~~~\includegraphics[width=0.98\columnwidth]{adert/adinv-borehole-cbar.pdf}%
\begin{itemize}
\item individually controlled regions
\item coupling to main region
\end{itemize}
\end{column}
\!\!\!\!\!\begin{column}[r]{0.22\columnwidth}
\includegraphics[width=0.95\columnwidth]{adert/adinv-borehole-compare-2.pdf}
\end{column}
\end{columns}
\end{block}
}%\only<2>
\only<3>{%
\begin{block}{Inversion result with regions (Fit: $\chi^2=1$)\phantom{S}}\centering
\begin{columns}
\begin{column}[r]{0.77\columnwidth}
~~~\begin{overpic}[width=\columnwidth]{adert/adinv-borehole-region.pdf}%
\end{overpic}\\[5pt]
~~~~~~~~\includegraphics[width=0.98\columnwidth]{adert/adinv-borehole-cbar.pdf}%
\begin{itemize}
\item clear bedrock boundary in the whole model
\item inter-bedding clay$/$sand$/$clay imaged close to direct push
\end{itemize}
\end{column}
\!\!\!\!\!\begin{column}[r]{0.22\columnwidth}
\includegraphics[width=0.95\columnwidth]{adert/adinv-borehole-compare-3.pdf}
\end{column}
\end{columns}
\end{block}
}%\only<3>
\end{frame}

\begin{frame}{Parameter information}{Effect of borehole fluid (Doetsch et al., 2010)}
	\only<1-2>{\includegraphics[width=0.48\columnwidth]{bhfluid/ubh1}}%
	\only<3>{\includegraphics[width=0.48\columnwidth]{bhfluid/bh1}}%
\hfill
	\begin{overpic}[width=0.48\columnwidth]{bhfluid/ubh2}%
		\only<2->{%
		\put(0,10){\includegraphics[width=0.48\columnwidth]{bhfluid/borehole}}
		\put(0,0){boreholes as separate regions}}
	\end{overpic}
	resistivity image (\only<1-2>{classic}\only<3>{with regions})
\end{frame}

\begin{frame}{Structural+parameter information}{Prior region model (Coscia et al., 2011)}
\only<1>{\begin{columns}
	\begin{column}{.3\textwidth}
	\begin{block}{RECORD project}
		\begin{itemize}
			\item renaturation of river Thur
			\item aim: river-/ground water exchange
			\item electrodes in 18 installed boreholes
			\item geological \& technical regions
		\end{itemize}
	\end{block}
	\end{column}
	\begin{column}{.7\textwidth}
		\includegraphics[width=\columnwidth]{ilaria/domain}
	\end{column}
\end{columns}}%
\only<2->{\begin{overpic}[width=\columnwidth]{ilaria/result}%
		\only<3>{\put(0,0){\includegraphics[width=\columnwidth]{ilaria/gravel}}}
	\end{overpic}}
\end{frame}

\begin{frame}{Error estimation}
\begin{columns}
\begin{column}{0.3\textwidth}
\begin{block}{How well can we fit the individual data?}
determines amount of smoothness

error models based on reciprocal data
(LaBrecque et al. 1992, Koestel et al. 2008, Udphuay et al. 2011):

statistics over bins of similar resistance
\end{block}
\end{column}
\begin{column}{0.7\textwidth}
\includegraphics[width=\columnwidth]{pdh-op-rec-paper}
\end{column}
\end{columns}
How about error analysis of temporal data?
\end{frame}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%% TIMELAPSE ERT %%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Timelapse ERT}
\subsection{Techniques and applications}
\begin{frame}{Timelapse inversion}%!!!
	\begin{block}{Timelapse inversion}
		\begin{itemize}
			\item selection from numerous approaches (schemes, constraints, error models)
			\item separate inversion yields artefacts, ratio inversion looses amplitude
			\item reference model (difference) inversion combines both
		\end{itemize}
	\end{block}

\begin{columns}[T]
    \begin{column}{0.5\textwidth}
		\includegraphics[width=\columnwidth]{ulla/brilliantblue}\\
		Verification with brilliant blue (C. Ganz (LUH) \& U. Noell (BGR))%%\\[3ex]
    \end{column}
    \begin{column}{0.5\textwidth}
		~\\[2ex]%\visible<2>{%
		\includegraphics[width=\columnwidth]{ulla/bert-result}%}
    \end{column}
\end{columns}
\end{frame}

\subsection{Hill-slope infiltration}
\begin{frame}{Hill-slope infiltration (group Prof. Kleber, TU Dresden)}
relative resistivity change after/before rainfall event
\includegraphics[width=\columnwidth]{mulda/mulda-bert1diff}\\
artifacts from imaging
\end{frame}


\begin{frame}{Hill-slope infiltration (group Prof. Kleber, TU Dresden)}
Problem-adapted scheme: partition in regions:\\
{\color{blue}background} - {\color{cyan}aquifer} - 
{\color[rgb]{0.5,0.5,0}vadose zone} - {\color[rgb]{0.8,0.1,0.1}bedrock}\\
\only<1>{Regions\\
\includegraphics[width=\columnwidth]{mulda/regions}\vspace{3ex}}%
\only<2>{Regions decoupled\\
\includegraphics[width=\columnwidth]{mulda/result0}}%
\only<3>{No changes in bedrock, only smooth changes in aquifer\\
\includegraphics[width=\columnwidth]{mulda/result1}}%
\only<4>{No changes in bedrock, only smooth changes in aquifer\\
\includegraphics[width=0.9767\columnwidth]{mulda/ratio-E}\vspace{2ex}}%
\end{frame}
\end{comment}

%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%
%\begin{appendix}

%CEM
%\subsection{The complete electrode model from EIT}
\begin{comment}
\begin{frame}{PEM vs. CEM (Rücker \& Günther 2011)}
\begin{columns}
\begin{column}{0.5\textwidth}
	\begin{block}{Mostly electrodes are considered points}
	\begin{itemize}
		\item extension small compared to distance
		\item contact impedances negligible (4-point measurements)
	\end{itemize}
	$\Rightarrow$ singular sources (discretization issue)
	\end{block}
\end{column}
\begin{column}{0.5\textwidth}
	\begin{block}{When do electrodes become finite?}
	\begin{itemize}
		\item very small distances (model tanks)
		\item plate electrodes (sealed ground)
		\item capacitively coupled line electrodes
		\item electrode rings in boreholes
		\item borehole casings as electrodes
	\end{itemize}
	\end{block}
\end{column}
\end{columns}
\vfill
\only<1>{\includegraphics[width=\textwidth]{cem/schaltbild}}%
\only<2>{\includegraphics[width=\textwidth]{cem/borehole}}%
\end{frame}

\begin{frame}{Fields and sensitivities of point vs. line electrodes (Rücker \& Günther 2011)}
\begin{overpic}[width=0.9\textwidth]{cem/cemsens}
\put(100,20){PEM}
\put(100,42){CEM}
\put(100,38){high $Z$}
\put(100,64){CEM}
\put(100,60){low $Z$}
\end{overpic}
\end{frame}

\begin{frame}{Beispiel einer pyGIMLi-Inversion (DC1D)}%
\footnotesize
ab2, mn2, rhoa = np.loadtxt(filename, unpack=True)\\
f = pg.DC1dModelling( nlay, ab2, mn2 )\\ 
transLog  = pg.RTransLog()  \# greater than zero (rhoa and thickness)\\
transRho  = pg.RTransLogLU(1, 1000) \# range constraint\\
f.region(0).setTransModel(transLog) \# thickness\\
f.region(1).setTransModel(transRho) \# resistivity\\
f.region( 0 ).setStartValue(np.max(ab2) / 3.0 / nlay)\\
f.region( 1 ).setStartValue(np.median(rhoa))\\[1ex]

INV = pg.RInversion(rhoa, f, True, transLog)\\
INV.setRelativeError(0.03)  \# 3 percent relative error\\
INV.setMarquardtScheme(0.9) \# decrease lambda by 10\% each iter\\
model = INV.run()\\[1ex]

fig, ax = P.subplots( 2, 1 )\\
draw1dmodel( model )\\
ax[1].loglog(rhoa, ab2, 'rx-', INV.response(), ab2, 'b-')
\end{frame}


\end{comment}

\begin{frame}{Examples for (unconventional) inversion with GIMLi}
\begin{block}{Block joint inversion of MRS and VES data (Günther\&Müller-Petke, 2012)}
Very simple concatenation of two forward operators
\end{block}
\begin{block}{MRS inversion for capillary fringe parameters (Costabel\&Günther, 2013)}
reduce smooth model to (3-5) soil model (van Genuchten) parameters
\end{block}
\begin{block}{Direct moisture content inversion of ERT and TDR data (van Nieuvenhuyse et al., 2013)}
Transformation problem in water-content ($\theta$) domain

constrain $\theta$ to reasonable ranges

Fit two data sets (ERT and TDR) such that:
\begin{itemize}
	\item only decreases are allowed (nonnegativity constraints)
	\item mass-balance ($\sum\theta=V_{in}$) as additional constraint
\end{itemize}
use sequential quadratic programming (SPQ) solver
\end{block}
\end{frame}

\begin{frame}{Sensitivity of Long Electrode ERT (Ronczka et al., 2013)}
\includegraphics[width=\textwidth]{samoleg/sens}
\end{frame}


\begin{frame}{pyGIMLi Module}
    (see pygimli API doc \url{http://pygimli.org/pygimliapi/})
    
    core - core functionality of C++ library GIMLi\\
    (see \url{http://pygimli.org/gimliapi/})
    
    inversion - inversion frameworks and tools, resolution
    
    io - Importing and exporting physics-independent stuff (GPS, formats)
    
    meshtools - tools for generating and manipulating meshes
    
    misc - miscellaneous (unsorted) functions
    
    mplviewer - Matplotlib-based functions for drawing models, data etc.
    
    viewer - ready-to-use wrapper functions for showing models, data etc. 
    
    solver - solver and associated tools for PDE/boundary value problems
    
    utils - utility functions for different purposes
    
    physics - modules for different methods (FDEM,MRS,SIP,TT,...)
\end{frame}

%\end{appendix}

\end{document}
